/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the FormatRuleRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &FormatRuleRequest{}

// FormatRuleRequest struct for FormatRuleRequest
type FormatRuleRequest struct {
	Column         *string `json:"column,omitempty"`
	ColumnWildcard *string `json:"column_wildcard,omitempty"`
	Function       *string `json:"function,omitempty"`
	Format         *string `json:"format,omitempty"`
}

// NewFormatRuleRequest instantiates a new FormatRuleRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewFormatRuleRequest() *FormatRuleRequest {
	this := FormatRuleRequest{}
	return &this
}

// NewFormatRuleRequestWithDefaults instantiates a new FormatRuleRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewFormatRuleRequestWithDefaults() *FormatRuleRequest {
	this := FormatRuleRequest{}
	return &this
}

// GetColumn returns the Column field value if set, zero value otherwise.
func (o *FormatRuleRequest) GetColumn() string {
	if o == nil || IsNil(o.Column) {
		var ret string
		return ret
	}
	return *o.Column
}

// GetColumnOk returns a tuple with the Column field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FormatRuleRequest) GetColumnOk() (*string, bool) {
	if o == nil || IsNil(o.Column) {
		return nil, false
	}
	return o.Column, true
}

// HasColumn returns a boolean if a field has been set.
func (o *FormatRuleRequest) HasColumn() bool {
	if o != nil && !IsNil(o.Column) {
		return true
	}

	return false
}

// SetColumn gets a reference to the given string and assigns it to the Column field.
func (o *FormatRuleRequest) SetColumn(v string) {
	o.Column = &v
}

// GetColumnWildcard returns the ColumnWildcard field value if set, zero value otherwise.
func (o *FormatRuleRequest) GetColumnWildcard() string {
	if o == nil || IsNil(o.ColumnWildcard) {
		var ret string
		return ret
	}
	return *o.ColumnWildcard
}

// GetColumnWildcardOk returns a tuple with the ColumnWildcard field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FormatRuleRequest) GetColumnWildcardOk() (*string, bool) {
	if o == nil || IsNil(o.ColumnWildcard) {
		return nil, false
	}
	return o.ColumnWildcard, true
}

// HasColumnWildcard returns a boolean if a field has been set.
func (o *FormatRuleRequest) HasColumnWildcard() bool {
	if o != nil && !IsNil(o.ColumnWildcard) {
		return true
	}

	return false
}

// SetColumnWildcard gets a reference to the given string and assigns it to the ColumnWildcard field.
func (o *FormatRuleRequest) SetColumnWildcard(v string) {
	o.ColumnWildcard = &v
}

// GetFunction returns the Function field value if set, zero value otherwise.
func (o *FormatRuleRequest) GetFunction() string {
	if o == nil || IsNil(o.Function) {
		var ret string
		return ret
	}
	return *o.Function
}

// GetFunctionOk returns a tuple with the Function field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FormatRuleRequest) GetFunctionOk() (*string, bool) {
	if o == nil || IsNil(o.Function) {
		return nil, false
	}
	return o.Function, true
}

// HasFunction returns a boolean if a field has been set.
func (o *FormatRuleRequest) HasFunction() bool {
	if o != nil && !IsNil(o.Function) {
		return true
	}

	return false
}

// SetFunction gets a reference to the given string and assigns it to the Function field.
func (o *FormatRuleRequest) SetFunction(v string) {
	o.Function = &v
}

// GetFormat returns the Format field value if set, zero value otherwise.
func (o *FormatRuleRequest) GetFormat() string {
	if o == nil || IsNil(o.Format) {
		var ret string
		return ret
	}
	return *o.Format
}

// GetFormatOk returns a tuple with the Format field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FormatRuleRequest) GetFormatOk() (*string, bool) {
	if o == nil || IsNil(o.Format) {
		return nil, false
	}
	return o.Format, true
}

// HasFormat returns a boolean if a field has been set.
func (o *FormatRuleRequest) HasFormat() bool {
	if o != nil && !IsNil(o.Format) {
		return true
	}

	return false
}

// SetFormat gets a reference to the given string and assigns it to the Format field.
func (o *FormatRuleRequest) SetFormat(v string) {
	o.Format = &v
}

func (o FormatRuleRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o FormatRuleRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Column) {
		toSerialize["column"] = o.Column
	}
	if !IsNil(o.ColumnWildcard) {
		toSerialize["column_wildcard"] = o.ColumnWildcard
	}
	if !IsNil(o.Function) {
		toSerialize["function"] = o.Function
	}
	if !IsNil(o.Format) {
		toSerialize["format"] = o.Format
	}
	return toSerialize, nil
}

type NullableFormatRuleRequest struct {
	value *FormatRuleRequest
	isSet bool
}

func (v NullableFormatRuleRequest) Get() *FormatRuleRequest {
	return v.value
}

func (v *NullableFormatRuleRequest) Set(val *FormatRuleRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableFormatRuleRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableFormatRuleRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableFormatRuleRequest(val *FormatRuleRequest) *NullableFormatRuleRequest {
	return &NullableFormatRuleRequest{value: val, isSet: true}
}

func (v NullableFormatRuleRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableFormatRuleRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
